/*
 * File:   Date.cpp
 * Author: Joe
 *
 * Created on February 17, 2011, 6:35 AM
 */

#include "Date.h"
#include <ctime>
using namespace std;

#ifdef _MSC_VER
#pragma warning(disable : 4996)
#endif

Date::Date(time_t arg) : value(arg)
{
}

// date format is "yyyy-mm-dd"

Date::Date(const std::string& date)
{
#ifdef __MINGW32__
    tm datetime {0,0,0,0,0,0,0,0,0};
#elif _MSC_VER
    tm datetime {0,0,0,0,0,0,0,0,0};
#else
    tm datetime {0,0,0,0,0,0,0,0,0,0,0};
#endif

    int temp;
    // get year
    temp = get_intFrom_stringAtPos(date, 0, 4);
    datetime.tm_year = temp - 1900;

    // get month
    temp = get_intFrom_stringAtPos(date, 5, 2);
    datetime.tm_mon = temp - 1;

    // get day of month
    temp = get_intFrom_stringAtPos(date,8,2);
    datetime.tm_mday = temp;
    datetime.tm_sec = datetime.tm_min = datetime.tm_hour = 1;

    value = mktime(&datetime);
}

Date::~Date()
{
}

int get_intFrom_stringAtPos(const std::string& str, size_t pos, size_t length)
{
    return stoi(str.substr(pos,length));
}

ostream & operator<<(ostream& out, const Date& dt)
{
    char buffer[ 80 ];
    tm* date = localtime(&(dt.value));

    strftime(buffer, sizeof (buffer), "%m/%d/%Y", date);
    out << buffer;
    return out;
}

// returns the difference in days
time_t Date::operator-(const Date& when) const
{
    if (*this == when)
        return 0;
    return (value-when.value)/24*60*60;
}

bool Date::operator<(const Date& date) const
{
    return value < date.value;
}

bool Date::operator>(const Date& date) const
{
    return value > date.value;
}

bool Date::operator>=(const Date& date) const
{
    return value >= date.value;
}

bool Date::operator==(const Date& date) const
{
    return value == date.value;
}
bool Date::operator<=(const Date& date) const
{
    return value <= date.value;
}

Date& Date::operator=(std::string text)
{
    Date temp(text);
    value = temp.value;
    return *this;
}

// prefix increment operator

Date& Date::operator++()
{
    value += 86400;
    return *this;
}

Date Date::operator+(int days) const  // add days to a Date
{
    Date temp(*this);
    temp.value += 86400 * days;
    return temp;
}


// postfix increment operator

Date Date::operator++(int)
{
    Date temp = *this;
    ++(*this);
    return temp;
}

// prefix decrement operator

Date& Date::operator--()
{
    value -= 86400;
    return *this;
}

// postfix decrement operator

Date Date::operator--(int)
{
    Date temp = *this;
    --(*this);
    return temp;
}

int Date::month() const
{
    struct tm* timeinfo = localtime(&value);
    return timeinfo->tm_mon;
}

int Date::dayOfMonth() const
{
    struct tm* timeinfo = localtime(&value);
    return timeinfo->tm_mday;
}

bool Date::operator!=(const Date& temp) const
{
    return value != temp.value;
}
